package rocks.zipcode.atm;

import javafx.scene.control.Label;
import rocks.zipcode.atm.bank.Bank;
import javafx.application.Application;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import javafx.scene.layout.FlowPane;

/**
 * @author ZipCodeWilmington
 */
public class CashMachineApp extends Application {

    private TextField field = new TextField();
    private CashMachine cashMachine = new CashMachine(new Bank());

    Stage mainStage;

    private Parent createContent() {
        VBox vbox = new VBox(10);
        vbox.setPrefSize(700, 500);

        TextArea areaInfo = new TextArea();

        Button btnSubmit = new Button("Get ID Info");
        btnSubmit.setOnAction(e -> {
            int id = Integer.parseInt(field.getText());
            cashMachine.login(id);

            areaInfo.setText(cashMachine.toString());
        });

        Button btnNewID = new Button("Create New ID");
        btnNewID.setOnAction(e -> {
            int id = Integer.parseInt(field.getText());
            cashMachine.newID(id);

            areaInfo.setText(cashMachine.toString());
        });

        Button btnNewName = new Button("Edit name");
        btnNewName.setOnAction(e -> {
            int id = Integer.parseInt(field.getText());
            cashMachine.newName(id);

            areaInfo.setText(cashMachine.toString());
        });

        Button btnNewEmail = new Button("Edit email");
        btnNewEmail.setOnAction(e -> {
            int id = Integer.parseInt(field.getText());
            cashMachine.newEmail(id);

            areaInfo.setText(cashMachine.toString());
        });


        Button btnDeposit = new Button("Deposit");
        btnDeposit.setOnAction(e -> {
            int amount = Integer.parseInt(field.getText());
            cashMachine.deposit(amount);

            areaInfo.setText(cashMachine.toString());
        });

        Button btnWithdraw = new Button("Withdraw");
        btnWithdraw.setOnAction(e -> {
            int amount = Integer.parseInt(field.getText());
            cashMachine.withdraw(amount);

            areaInfo.setText(cashMachine.toString());
        });

        Button btnExit = new Button("Exit");
        btnExit.setOnAction(e -> {
            cashMachine.exit();

            areaInfo.setText(cashMachine.toString());
        });

        FlowPane flowpane = new FlowPane();

        flowpane.getChildren().add(btnSubmit);
        flowpane.getChildren().add(btnNewID);
        flowpane.getChildren().add(btnNewName);
        flowpane.getChildren().add(btnNewEmail);
        flowpane.getChildren().add(btnDeposit);
        flowpane.getChildren().add(btnWithdraw);
        flowpane.getChildren().add(btnExit);
        vbox.getChildren().addAll(field, flowpane, areaInfo);
        return vbox;
    }


//    private Parent mainScene() {
//        VBox vbox = new VBox(10);
//        vbox.setPrefSize(700, 500);
//
//        Scene scene1 = createContent();
//
//        Label label1 = new Label("Welcome to the first scene!");
//        Button button1 = new Button("Go to scene 2");
//        button1.setOnAction(e -> mainStage.setScene(createContent()));
//
//        return vbox;
//    }

    @Override
    public void start(Stage stage) throws Exception {
        // mainStage = stage;
        stage.setScene(new Scene(createContent()));
        // Scene loggedIn = new Scene(mainScene());
        stage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
